//-------------------------------------------------------------------------------------
//          Copyright ? 2005-2006 META                                             
//                All Rights Reserved.                                                 
//   The file is generated by Component Wizard for QUALCOMM Mobile Platform            
// FileName:   CMetaRecord.h                                                                      
// Author:     nick                                                                      
// Date:       2006-02-20                                                                      
// Log:   Author             Date             Description                              
// ------------------------------------------------------------------------------------
//        nick        2006-02-20       Generate source file frame   
//        nick        20096-04-01       	     Modify  
//-------------------------------------------------------------------------------------

#ifndef __IMETADBRECORD_H__
#define __IMETADBRECORD_H__

#include "AEE.h"
#include "AEEShell.h"
#include "AEEComdef.h"
#include "AEEInterface.h"
#include "IMetaDB.h"


//////////////////////////////////////////////////////////////////////////
// Please define META_CLSID_IMetaDBRecord                                            
//////////////////////////////////////////////////////////////////////////
typedef long int32;
typedef unsigned short ushort;

typedef enum
{
	META_FIELD_TEXT  = 0,
	META_FIELD_WTEXT = 1,
	META_FIELD_INT32 = 2,
	META_FIELD_INT64 = 3,
	META_FIELD_NULL  = 4,
	META_FIELD_BINARY= 5,
	META_FIELD_TIME  = 6
}TMetaFieldTypeEnum;

	
typedef struct 
{
	TMetaFieldTypeEnum type;//indentify the field value type
	int fieldID;//indentify the field
	//AEECHAR fieldName[MAX_METADB_FIELD_SIZE];
} TMetaDBFieldDesc;


typedef struct
{
	TMetaDBFieldDesc fieldDesc;//indentify the field info
	int   len; //length of pData
	int32 pData[1];
} TMetaDBRecordData;

#define META_DBRECORD_SIZE (sizeof(TMetaDBRecordData) - sizeof(int32))
#define CALC_META_DBRECORD_SIZE(pRecord) (META_DBRECORD_SIZE + pRecord->len)

#define INT32_META_DBRECORD_SIZE (META_DBRECORD_SIZE + sizeof(int32))

typedef struct IMetaDBRecord IMetaDBRecord;

static int MetaDBRecordData_CreateFieldData(TMetaDBRecordData** ppRecordData, int nFieldId, TMetaFieldTypeEnum dataType, void* pRawData, int nDataSize);

static int MetaDBRecordData_CreateFieldDataWText(TMetaDBRecordData** ppRecordData, int nFieldId, AECHAR* pwzStr, int nBytes);
static int MetaDBRecordData_CreateFieldDataBinary(TMetaDBRecordData** ppRecordData, int nFieldId, char* pszStr, int nBytes);
static int MetaDBRecordData_CreateFieldDataInt32(TMetaDBRecordData** ppRecordData, int nFieldId, int nNumber);

void TMetaDBRecordData_ToString(TMetaDBRecordData* pSrc, AECHAR* buffer, int nSize);
void TMetaDBRecordData_DataToString(TMetaDBRecordData* pSrc, AECHAR* buffer, int nSize);
int WSTRTOUL(AECHAR* src);

static int TMetaDBRecordData_Clone(TMetaDBRecordData* pSrc, TMetaDBRecordData** ppDst);
static int TMetaDBRecordData_Copy(TMetaDBRecordData* pSrc, TMetaDBRecordData** ppDst);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



AEEINTERFACE(IMetaDBRecord)
{
	INHERIT_IQueryInterface(IMetaDBRecord);

	// the parameter is for both input and output, the memory release of "pData" of "pRecordData" is user's responsibility
	int  (*GetFieldCount)(IMetaDBRecord* pIMetaDBRecord, ushort* pFieldCount);	
	int  (*InsertField) (IMetaDBRecord* pIMetaDBRecord, TMetaDBRecordData* pRecordData);
	int  (*RemoveFieldById) (IMetaDBRecord* pIMetaDBRecord, int nFieldId);
	int  (*RemoveFieldByIndex)(IMetaDBRecord* pIMetaDBRecord, ushort nIndex);
	int  (*GetFieldPointerById)(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaDBRecordData** ppRecordData);
	int  (*GetFieldPointerByIndex)(IMetaDBRecord* pIMetaDBRecord, ushort nFieldIndex, TMetaDBRecordData** ppRecordData);
	int  (*InsertFieldData)(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaFieldTypeEnum dataType, void* pRawData, int nDataSize);
	int  (*RemoveAll)(IMetaDBRecord* pIMetaDBRecord);
};

struct IMetaDBRecord
{
    const AEEVTBL(IMetaDBRecord) *pvt;
    void* pData;
};

#define IMetaDBRecord_AddRef(pThis) \
	AEEGETPVTBL((pThis),IMetaDBRecord)->AddRef(pThis)
	
#define IMetaDBRecord_Release(pThis) \
	AEEGETPVTBL((pThis),IMetaDBRecord)->Release(pThis)
	
#define IMetaDBRecord_QueryInterface(pThis,ClsID,ppInterface)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->QueryInterface(pThis,ClsID,ppInterface)
////////////////////////////////////////////////////////////////////////////////////////////////

#define IMetaDBRecord_GetFieldCount(pThis,pFieldCount)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->GetFieldCount(pThis,pFieldCount)

#define IMetaDBRecord_InsertField(pThis,pRecordData)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->InsertField(pThis,pRecordData)

#define IMetaDBRecord_RemoveFieldById(pThis,nFieldId)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->RemoveFieldById(pThis,nFieldId)


#define IMetaDBRecord_RemoveFieldByIndex(pThis,nIndex)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->RemoveFieldByIndex(pThis,nIndex)


#define IMetaDBRecord_GetFieldPointerById(pThis,nFieldId,ppRecordData)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->GetFieldPointerByI(pThis,nFieldId,ppRecordData)

#define IMetaDBRecord_GetFieldPointerByIndex(pThis,nFieldIndex,ppRecordData)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->GetFieldPointerByIndex(pThis,nFieldIndex,ppRecordData)

#define IMetaDBRecord_InsertFieldData(pThis,nFieldId,dataType,pRawData,nDataSize) \
	AEEGETPVTBL((pThis),IMetaDBRecord)->InsertFieldData(pThis,nFieldId,dataType,pRawData,nDataSize)

#define IMetaDBRecord_RemoveAll(pThis)  \
	AEEGETPVTBL((pThis),IMetaDBRecord)->RemoveAll(pThis)

#endif
